#include "config.h"

#define VERSION            "0.3"
#define HTTP_GET           1
#define HTTP_POST          2
#define VERBOSE_LEVEL_1    1
#define VERBOSE_LEVEL_2    2
#define VERBOSE_LEVEL_3    3
#define YES                1
#define NO                 0

int requests_count,
    bytes_sent,
    bytes_received,
    quiet,
    nospinner,
    mode_macro,
    verbose,
    interrupt,
    last_interrupt;

/* proprotypes */
int is_num(const char *str);
extern char *strcasestr (__const char *__haystack, __const char *__needle);
int asprintf(char **strp, const char *fmt, ...);
char *str_replace(const char *search, const char *replace, const char *string);
char enum_char(struct configuration *conf, const char* query, int pos, int start_char, int end_char);
int match_reponse(const char* http_req, struct configuration *conf);
void spinner(void);
int enum_query(struct configuration *conf, const char *query);
int enum_query_all_rows(struct configuration *conf);
char *char_encode_strings(const char *buffer, const int encoding);
char *char_encode_string(const char *buffer, const int encoding);
char *build_injection_request(struct configuration *conf, const char *query, unsigned int pos, char start_chr, char end_chr);
void debug_msg(unsigned short int verbose_level, const char* fmt, ...);
void macro_mode_start(struct configuration *conf);
void macro_enum_db(struct configuration *conf);
void macro_enum_tables(struct configuration *conf);
void macro_enum_fields(struct configuration *conf);
void macro_enum_data(struct configuration *conf, const char *title, const char *query);
void macro_enum_data_all_rows(struct configuration *conf, const char *title, char *query);
void macro_enum_file(struct configuration *conf);
void macro_enum_test(struct configuration *conf);
int parse_config_file(const char *config_file, struct configuration *conf);
int socket_connect(const char* hostname, unsigned short int port);
void socket_close(int sd);
char *http_request(const char* http_req, struct configuration *conf);
int str_empty (char *str);
char *trim (char *string);
void interrupt_enumeration(void);

